<?php
/*
Plugin Name: Free Website Monitoring
Plugin URI: http://roundtripemail.com/wordpress
Description: This plugin provides free monitoring and alerting for your wordpress website. Powered by RoundTripEmail.com.
Version: 0.3  
Author: MinneApp, LLC
Author URI: http://www.minneapp.com
*/

/*  
Copyright 2012  MinneApp, LLC  (email : support@minneapp.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/* -------- Administration -------- */
add_action('admin_menu', 'roundTripEmail_options');

function roundTripEmail_options() {	
	add_options_page('Options for Free Website Monitoring by RoundTripEmail.com', 'Website Monitoring', 'administrator', __FILE__, 'roundTripEmail_options_page');
	  
}

add_action( 'admin_init', 'roundTripEmail_register_options'  );
function roundTripEmail_register_options() {
	register_setting( 'roundTripEmail_options', 'rt_options', 'roundTripEmail_validate_options' );
}

function roundTripEmail_validate_options( $input ) {
  $input['roundTripEmail_alert'] = filter_var($input['roundTripEmail_alert'], FILTER_VALIDATE_EMAIL);	
  $input['roundTripEmail_promoted'] = ($input['roundTripEmail_promoted'] == 1 || $input['roundTripEmail_promoted'] == 0 ) ? $input['roundTripEmail_promoted'] : 1;
  
  return $input;
}

function roundTripEmail_options_page() {
	include ('free-website-monitoring-options.php');
}


/* -------- Header -------- */
add_action('wp_head', 'roundTripEmail_head');
function roundTripEmail_head() {
  if ( !is_admin() ) echo '<meta name="roundtripemail" content="'.get_option('roundTripEmail_token').'" />' . "\n";
}

/* -------- Footer -------- */
add_action('wp_footer', 'roundTripEmail_footer');
function roundTripEmail_footer() {
  $settings = get_option('rt_options');
  $footerLink = $settings['roundTripEmail_promote'];
  if ( $footerLink ) {
  	echo 'Website Monitoring by <a href="http://roundtripemail.com/wordpress" target="_blank" title="Round Trip Email Monitoring" id="roundtripemail">Round Trip Email Monitoring</a>';
  }
}

/* -------- Activation -------- */
register_activation_hook( __FILE__, 'roundTripEmail_activate' );
function roundTripEmail_activate() {
  if ( ! $token = get_option('roundTripEmail_token') ) 
    $token = roundTripEmail_genRandomString();
  update_option('roundTripEmail_token', $token );
  $rt_options = array( 'roundTripEmail_alert' => '', 'roundTripEmail_promote' => 1);
  $settings = get_option('rt_options', $rt_options);
  
  roundTripEmail_updateMonitor();
}


/* -------- Deactivation -------- */
register_uninstall_hook(__FILE__, 'roundTripEmail_deactivate');
register_deactivation_hook( __FILE__, 'roundTripEmail_deactivate');
function roundTripEmail_deactivate() {  
  $return = file_get_contents('http://roundtripemail.com/website/disable/'.roundTripEmail_genHash());
}



/* ---------------------------------- */
/* -------- Helper Functions -------- */
/* ---------------------------------- */
function roundTripEmail_updateMonitor() {
  return file_get_contents('http://roundtripemail.com/website/enable/'.roundTripEmail_genHash());
}

function roundTripEmail_genRandomString($length = 64) {
  $characters = '0123456789abcdefghijklmnopqrstuvwxyz';
  $string = '';    
  for ($p = 0; $p < $length; $p++) {
      $string .= $characters[mt_rand(0, strlen($characters)-1)];
  }
  return $string;
}

function roundTripEmail_genHash() {
  $settings = get_option('rt_options');
  $values = array('roundTripEmail_token' => get_site_option('roundTripEmail_token'), 
    'roundTripEmail_alert' => $settings['roundTripEmail_alert'],
    'roundTripEmail_feedback' => $settings['roundTripEmail_feedback'],
    'roundTripEmail_website' => get_bloginfo('wpurl'),
    'roundTripEmail_promoted' => $settings['roundTripEmail_promote']
  );
  $hash = base64_encode(serialize($values));
  return $hash;
}